'  Copyright  2005 Robert D. Riemersma, Jr.
'
'  Permission is granted to use and distribute this software without
'  charge, provided this notice is retained. Derivative works are
'  encouraged.
'
'  No guarantees are made, no support is promised, nor are any
'  liabilities accepted. This material is provided for general use
'  *as is*.

Option Explicit

Const adoJet4x = 5 'Access 2000
Const adStateOpen = 1
Const adExecuteNoRecords = &H80
Const adOpenForwardOnly = 0
Const adOpenDynamic = 2
Const adOpenStatic = 3
Const adLockReadOnly = 1
Const adLockPessimistic = 2
Const adLockOptimistic = 3
Const adCmdText = 1
Const adCmdTable = 2

Const RESFOLDER = "\Resource" 'Resource folder name only.
Const DB = "\FWDiscus.mdb"
Const HTAICON = "\FWDiscus.ico"
Const BACKUPDB = "\Backup.mdb"
Const JETCOMP = "\JETCOMP.exe"

Const DBVERSION = "DB Version 003"
Const NEVERDATE = #1 Jan 1970 00:00 AM#

Dim strHTAPath     'Full path to this HTA.
Dim strHTADir      'Full path & dir containing this HTA.
Dim strHTAName     'Name of the HTA sans extension.
Dim strResourceDir 'Full path & dir containing the HTA's resource files.
Dim strConn
Dim strTopicsQuery
Dim strUser
Dim strBTitle
Dim strBSubtitle
Dim strBPurpose
Dim intRefresh
Dim blnQuietMode
Dim blnLocked
Dim intTimer
Dim intRefreshCount 'Half minutes.
Dim objConn
Dim objRS
Dim dicVisited

Function HTMLEncode(ByVal strText)
  strText = Replace(strText, "&", "&amp;")
  strText = Replace(strText, "<", "&lt;")
  strText = Replace(strText, ">", "&gt;")
  strText = Replace(strText, """", "&quot;")
  strText = Replace(strText, "  ", "&nbsp; ")
  strText = Replace(strText, "[b]", "<B>", 1, -1, vbTextCompare)
  strText = Replace(strText, "[/b]", "</B>", 1, -1, vbTextCompare)
  strText = Replace(strText, "[i]", "<I>", 1, -1, vbTextCompare)
  strText = Replace(strText, "[/i]", "</I>", 1, -1, vbTextCompare)
  strText = Replace(strText, "[u]", "<U>", 1, -1, vbTextCompare)
  strText = Replace(strText, "[/u]", "</U>", 1, -1, vbTextCompare)
  strText = Replace(strText, "[tt]", "<TT>", 1, -1, vbTextCompare)
  strText = Replace(strText, "[/tt]", "</TT>", 1, -1, vbTextCompare)
  strText = Replace(strText, "[[", "[")
  strText = Replace(strText, "]]", "]")
  HTMLEncode = Replace(strText, vbNewLine, "<BR>")
End Function

Function HTMLDecode(ByVal strText)
  strText = Replace(strText, "<BR>", vbNewLine)
  strText = Replace(strText, "]", "]]")
  strText = Replace(strText, "[", "[[")
  strText = Replace(strText, "</TT>", "[/tt]")
  strText = Replace(strText, "<TT>", "[tt]")
  strText = Replace(strText, "</U>", "[/u]")
  strText = Replace(strText, "<U>", "[u]")
  strText = Replace(strText, "</I>", "[/i]")
  strText = Replace(strText, "<I>", "[i]")
  strText = Replace(strText, "</B>", "[/b]")
  strText = Replace(strText, "<B>", "[b]")
  strText = Replace(strText, "&nbsp; ", "  ")
  strText = Replace(strText, "&quot;", """")
  strText = Replace(strText, "&gt;", ">")
  strText = Replace(strText, "&lt;", "<")
  HTMLDecode = Replace(strText, "&amp;", "&")
End Function

Function SearchableEncode(ByVal strText)
  strText = Replace(strText, "[b]", "", 1, -1, vbTextCompare)
  strText = Replace(strText, "[/b]", "", 1, -1, vbTextCompare)
  strText = Replace(strText, "[i]", "", 1, -1, vbTextCompare)
  strText = Replace(strText, "[/i]", "", 1, -1, vbTextCompare)
  strText = Replace(strText, "[u]", "", 1, -1, vbTextCompare)
  strText = Replace(strText, "[/u]", "", 1, -1, vbTextCompare)
  strText = Replace(strText, "[tt]", "", 1, -1, vbTextCompare)
  strText = Replace(strText, "[/tt]", "", 1, -1, vbTextCompare)
  strText = Replace(strText, vbNewLine, " ")
  strText = Replace(strText, """", " ")
  strText = Replace(strText, ".", " ")
  strText = Replace(strText, "!", " ")
  strText = Replace(strText, "?", " ")
  strText = Replace(strText, ", ", " ")
  strText = Replace(strText, ",", " ")
  strText = Replace(strText, "; ", " ")
  strText = Replace(strText, ";", " ")
  strText = Replace(strText, ": ", " ")
  strText = Replace(strText, ":", " ")
  strText = Replace(strText, " - ", " ")
  strText = Replace(strText, "-", " ")
  strText = Replace(strText, "/", " ")
  strText = Replace(strText, "(", " ")
  strText = Replace(strText, ")", " ")
  SearchableEncode = " " & strText & " "
End Function

Function SearchStringEncode(ByVal strText)
  strText = Replace(strText, ".", " ")
  strText = Replace(strText, "!", " ")
  strText = Replace(strText, "?", " ")
  strText = Replace(strText, ", ", " ")
  strText = Replace(strText, ",", " ")
  strText = Replace(strText, "; ", " ")
  strText = Replace(strText, ";", " ")
  strText = Replace(strText, ": ", " ")
  strText = Replace(strText, ":", " ")
  strText = Replace(strText, "/", " ")
  strText = Replace(strText, "(", " ")
  SearchStringEncode = Replace(strText, ")", " ")
End Function

Function ParseSearchString(ByVal strText)
  Dim aryTerms
  Dim lngTerm
  Dim strTerm
  Dim strSQL
  Dim blnGotFirst

  aryTerms = Split(SearchStringEncode(strText), """")
  For lngTerm = 0 To UBound(aryTerms) Step 2
    aryTerms(lngTerm) = Replace(aryTerms(lngTerm), " ", vbFormFeed) & vbFormFeed
  Next
  strText = Join(aryTerms, "")

  aryTerms = Split(strText, vbFormFeed)
  strSQL = ""
  blnGotFirst = False
  For lngTerm = 0 To UBound(aryTerms)
    strTerm = aryTerms(lngTerm)
    If Len(strTerm) > 0 Then
      If strTerm = "-" Or UCase(strTerm) = "NOT" Then
        If lngTerm < UBound(aryTerms) Then
          aryTerms(lngTerm + 1) = "-" & aryTerms(lngTerm + 1)
        End If
      Else
        If blnGotFirst Then
          strSQL = strSQL & " AND"
        Else
          strSQL = strSQL & " WHERE"
          blnGotFirst = True
        End If
        If Left(strTerm, 1) = "-" Then
          strSQL = strSQL & " NOT"
          strTerm = Mid(strTerm, 2)
        End If
        strSQL = strSQL & " fldSearchable LIKE ""% " & strTerm & " %"""
      End If
    End If
  Next
  ParseSearchString = strSQL
End Function

Sub ShowPanelTest(ByVal P, ByVal Candidate)
  If P Is Candidate Then
    Candidate.style.display = "block"
  Else
    Candidate.style.display = "none"
  End If
End Sub

Sub ShowPanel(ByVal P)
  ShowPanelTest P, TopicListPanel
  ShowPanelTest P, ViewTopicPanel
  ShowPanelTest P, EditReplyPanel
  ShowPanelTest P, NewTopicPanel
  ShowPanelTest P, SearchPanel
  ShowPanelTest P, SearchResultsPanel
  ShowPanelTest P, SettingsPanel
End Sub

Sub GetPaths()
  Dim lngSeg, lngDelim

  strHTAPath = window.location.pathname
  strHTAPath = Split(Replace(strHTAPath, "+", " "), "%")
  For lngSeg = 1 To UBound(strHTAPath)
    strHTAPath(lngSeg) = Chr(CInt("&H" & Left(strHTAPath(lngSeg), 2))) & Mid(strHTAPath(lngSeg), 3)
  Next
  strHTAPath = Join(strHTAPath, "")
  If Left(strHTAPath, 1) = "/" Then strHTAPath = Mid(strHTAPath, 2)
  strHTAPath = CreateObject("Scripting.FileSystemObject").GetFile(strHTAPath).ShortPath
  lngDelim = InStrRev(strHTAPath, "\")
  strHTADir = Left(strHTAPath, lngDelim - 1)
  strResourceDir = strHTADir & RESFOLDER
  strHTAName = Mid(strHTAPath, lngDelim + 1)
  lngDelim = InStrRev(strHTAName, ".")
  strHTAName = Left(strHTAName, lngDelim - 1)
End Sub

Sub BuildGlobalStrings()
  GetPaths
  strConn = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=""" & strResourceDir & DB & """"
  strTopicsQuery = _
      "SELECT fldTID, fldTitle, fldPosted, fldPostedBy, fldViews," _
          & " (SELECT Count(1) FROM tblReplies WHERE tblTopics.fldTID = tblReplies.fldTID) As ReplyCount" _
      & " FROM tblTopics ORDER BY fldPosted DESC"
End Sub

Function DBVersionTest()
  On Error Resume Next
  objConn.Open strConn
  If Err.Number <> 0 Then
    DBVersionTest = "" 'Database not present.
  Else
    With objRS
      .Open "SELECT fldDBVersion FROM tblInfo", objConn, adOpenStatic, adLockReadOnly, adCmdText
      If Err.Number <> 0 Then
        'Missing version field, call it version 1.
        DBVersionTest = "DB Version 001"
      Else
        On Error GoTo 0
        DBVersionTest = .Fields("fldDBVersion").Value
      End If
      .Close
    End With
  End If
End Function

Sub CreateDB()
  CreateObject("ADOX.Catalog").Create _
    strConn & ";" & "Jet OLEDB:Engine Type=" & CStr(adoJet4x)

  With objConn
    .Open strConn
    .Execute _
      "CREATE TABLE tblInfo(" _
        & "fldDBVersion TEXT(14) WITH COMP NOT NULL, " _
        & "fldTitle TEXT(60) WITH COMP NOT NULL, " _
        & "fldSubtitle TEXT(100) WITH COMP NOT NULL, " _
        & "fldPurpose MEMO WITH COMP NOT NULL, " _
        & "fldRefresh SMALLINT NOT NULL, " _
        & "fldLocked YESNO NOT NULL, " _
        & "fldStarted TIMESTAMP NOT NULL)", , _
      adExecuteNoRecords
    With objRS
      .Open "tblInfo", objConn, adOpenStatic, adLockOptimistic, adCmdTable
      .AddNew
      .Fields("fldDBVersion").Value = DBVERSION
      .Fields("fldTitle").Value = "New FWDiscus Board"
      .Fields("fldSubtitle").Value = _
          "Please update this information through the ""Settings"" option"
      .Fields("fldPurpose").Value = _
          "Provide a brief welcome and <U>statement of purpose</U> for your discussion " _
        & "board <I>here</I>. This text can also contain short reminders or announcements."
      .Fields("fldRefresh").Value = 10
      .Fields("fldLocked").Value = False
      .Fields("fldStarted").Value = Now
      .Update
      .Close
    End With
    .Execute _
      "CREATE TABLE tblTopics(" _
        & "fldTID IDENTITY CONSTRAINT PK_fldTID PRIMARY KEY, " _
        & "fldTitle TEXT(100) WITH COMP NOT NULL, " _
        & "fldPosted TIMESTAMP NOT NULL, " _
        & "fldPostedBy TEXT(40) WITH COMP NOT NULL, " _
        & "fldViews INTEGER NOT NULL)", , _
      adExecuteNoRecords
    .Execute _
      "CREATE TABLE tblReplies(" _
        & "fldRID IDENTITY CONSTRAINT PK_fldRID PRIMARY KEY, " _
        & "fldTID INTEGER NOT NULL CONSTRAINT FK_fldTID REFERENCES tblTopics(fldTID) " _
          & "ON DELETE CASCADE, " _
        & "fldTopicHead YESNO NOT NULL, " _
        & "fldPosted TIMESTAMP NOT NULL, " _
        & "fldPostedBy TEXT(40) WITH COMP NOT NULL, " _
        & "fldText MEMO WITH COMP NOT NULL, " _
        & "fldSearchable MEMO WITH COMP NOT NULL, " _
        & "fldEdited TIMESTAMP NOT NULL, " _
        & "fldEditedBy TEXT(40) WITH COMP NOT NULL)", , _
      adExecuteNoRecords
  End With
End Sub

Function GetTopics(ByVal strQuery, ByVal strMsg)
  Dim strList
  Dim TID

  If objConn.State <> adStateOpen Then
    objConn.Open strConn
  End If
  objRS.Open strQuery, objConn, adOpenStatic, adLockReadOnly, adCmdText
  If objRS.RecordCount = 0 Then
    strList = "<P><I>No topics " & strMsg & "!</I></P>"
  Else
    strList = ""
    With objRS
      Do Until .EOF
        TID = .Fields("fldTID").Value
        strList = strList _
                & "<P><SPAN class="""
        If dicVisited.Exists(TID) Then
          strList = strList & "TopicTitleVisited"
        Else
          strList = strList & "TopicTitle"
        End If
        strList = strList _
                & """ onclick=""VBScript: ShowTopic " _
                & CStr(TID) _
                & ", Me"">" _
                & .Fields("fldTitle").Value _
                & "</SPAN>&nbsp; <SPAN class=""Smaller"">" _
                & CStr(.Fields("fldPosted").Value) _
                & "&nbsp;&nbsp;" _
                & .Fields("fldPostedBy").Value _
                & "</SPAN>&nbsp; <SPAN class=""SmallerHighlight"">(" _
                & CStr(.Fields("fldViews").Value) _
                & " views, " _
                & CStr(.Fields("ReplyCount").Value - 1) _
                & " replies)</SPAN></P>"
        .MoveNext
      Loop
    End With
  End If
  objRS.Close
  objConn.Close
  GetTopics = strList
End Function

Function ListTopics_onclick()
  TopicListBody.innerHTML = GetTopics(strTopicsQuery, "in this discussion yet")
  ShowPanel TopicListPanel
  ListTopics_onclick = False 'Cancel navigation.
End Function

Function RefreshTopicsList()
  intRefreshCount = intRefreshCount - 1
  If intRefreshCount < 1 Then
    intRefreshCount = intRefresh * 2 'We count down half-minute intervals.
    If TopicListPanel.style.display = "block" Then
      TopicListBody.innerHTML = GetTopics(strTopicsQuery, "in this discussion yet")
    End If
  End If
End Function

Sub ShowTopic(ByVal TID, ByVal objClicked)
  Dim lngOpenType
  Dim lngTopicsLock
  Dim strTitle
  Dim strList

  If blnLocked Then
    lngOpenType = adOpenStatic
    lngTopicsLock = adLockReadOnly
  Else
    lngOpenType = adOpenDynamic
    lngTopicsLock = adLockPessimistic
  End If

  objConn.Open strConn
  With objRS
    .Open "SELECT * FROM tblTopics WHERE fldTID = " & CStr(TID), _
          objConn, lngOpenType, lngTopicsLock, adCmdText

    If .EOF Then
      MsgBox "That topic has been deleted.  You may wish" & vbNewLine _
           & "to refresh the list before selecting another.", _
             vbOkOnly Or vbInformation, "FWDiscus"
      objClicked.disabled = True
      objClicked.title = "This topic has been deleted"
      objRS.Close
      objConn.Close
      Exit Sub
    End If

    strTitle = .Fields("fldTitle").Value
    If Not blnLocked And Not blnQuietMode Then
      .Fields("fldViews").Value = .Fields("fldViews").Value + 1
      .Update
    End If
    .Close

    .Open "SELECT * FROM tblReplies WHERE fldTID = " & CStr(TID) & " ORDER BY fldPosted ASC", _
          objConn, adOpenStatic, adLockReadOnly, adCmdText
    If .RecordCount < 1 Then
      strList = "&nbsp;"
      ReplyList.style.display = "none"
    Else
      strList = ""
      Do Until .EOF
        strList = strList _
                & "<DIV class=""Boxed"">"
        If .Fields("fldTopicHead") Then
          strList = strList _
                  & "<DIV class=""LargerHighlight"">" _
                  & strTitle _
                  & "</DIV>"
        End If
        strList = strList _
                & "<DIV>" _
                & .Fields("fldText").Value _
                & "</DIV>"
        If .Fields("fldEdited").Value <> NEVERDATE Then
          strList = strList _
                  & "<DIV class=""EditedLine""><I>Edited:</I> " _
                  & CStr(.Fields("fldEdited").Value) _
                  & "&nbsp; " _
                  & .Fields("fldEditedBy").Value _
                  & "</DIV>"
        Else
          strList = strList _
                  & "<DIV>&nbsp;</DIV>"
        End If
        strList = strList _
                & "<DIV class=""SmallerHighlight"">" _
                & CStr(.Fields("fldPosted").Value) _
                & "&nbsp; " _
                & .Fields("fldPostedBy").Value
        If Not blnLocked Then
          strList = strList _
                  & "&nbsp; &nbsp; <SPAN class=""EditDeleteLink"" onclick=""VBScript: EditReply " _
                  & CStr(.Fields("fldRID").Value) _
                  & """>Edit</SPAN>&nbsp; &nbsp; <SPAN class=""EditDeleteLink"" onclick="""
          If .Fields("fldTopicHead").Value Then
            strList = strList _
                    & "VBScript: DeleteTopic " _
                    & CStr(.Fields("fldTID").Value) _
                    & """>Delete whole topic</SPAN>"
          Else
            strList = strList _
                    & "VBScript: DeleteReply " _
                    & CStr(.Fields("fldRID").Value) _
                    & """>Delete</SPAN>"
          End If
        End If
        strList = strList _
                & "</DIV></DIV>"
        .MoveNext
      Loop
      ReplyList.style.display = "block"
    End If
    .Close
  End With
  objConn.Close
  ReplyList.innerHTML = strList

  With NewReplyForm
    If blnLocked Then
      NewReplyFormBox.className = "BoxedFormNoDisplay"
    Else
      .TID.value = CStr(TID)
      .By.value = strUser
      NewReplyFormBox.className = "BoxedForm"
    End If
  End With
  ShowPanel ViewTopicPanel

  If Not dicVisited.Exists(TID) Then
    dicVisited.Add TID, 0
    objClicked.className = "TopicTitleVisited"
  End If
End Sub

Sub PreviewNewTopic_onclick()
  PreviewNewTopicText.innerHTML = HTMLEncode(NewTopicForm.Text.value)
  PreviewNewTopicInput.style.display = "block"
End Sub

Sub SubmitNewTopic_onclick()
  Dim dtNow
  Dim lngTID

  With NewTopicForm
    If Len(.Title.value) = 0 Or Len(.By.value) = 0 Or Len(.Text.value) = 0 Then
      MsgBox "Please complete all fields.", vbExclamation Or vbOkOnly, "FWDiscus"
    Else
      strUser = HTMLEncode(.By.value)
      objConn.Open strConn
      objConn.BeginTrans
      dtNow = Now
      With objRS
        .Open "tblTopics", objConn, adOpenDynamic, adLockPessimistic, adCmdTable
        .AddNew
        .Fields("fldTitle").Value = HTMLEncode(NewTopicForm.Title.value)
        .Fields("fldPosted").Value = dtNow
        .Fields("fldPostedBy").Value = strUser
        .Fields("fldViews").Value = 0
        .Update
        .Close

        .Open "SELECT @@IDENTITY", objConn, adOpenStatic, adLockPessimistic, adCmdText
        lngTID = .Fields(0).Value
        .Close

        .Open "tblReplies", objConn, adOpenDynamic, adLockPessimistic, adCmdTable
        .AddNew
        .Fields("fldTID").Value = lngTID
        .Fields("fldTopicHead").Value = True
        .Fields("fldPosted").Value = dtNow
        .Fields("fldPostedBy").Value = strUser
        .Fields("fldText").Value = HTMLEncode(NewTopicForm.Text.value)
        .Fields("fldSearchable").Value = SearchableEncode(NewTopicForm.Title.value) _
                                       & "|" _
                                       & SearchableEncode(NewTopicForm.Text.value)
        .Fields("fldEdited").Value = NEVERDATE
        .Fields("fldEditedBy").Value = ""
        .Update
        .Close
      End With
      objConn.CommitTrans
      .By.setAttribute "UserName", strUser
      .By.save "DiscusUserData"
      .reset
      PreviewNewTopicInput.style.display = "none"
      ListTopics_onclick
    End If
  End With
End Sub

Sub CancelNewTopic_onclick()
  NewTopicForm.reset
  PreviewNewTopicInput.style.display = "none"
  ListTopics_onclick
End Sub

Function NewTopic_onclick()
  NewTopicForm.By.value = HTMLDecode(strUser)
  ShowPanel NewTopicPanel
  NewTopicForm.Title.focus
  NewTopic_onclick = False
End Function

Sub DeleteTopic(ByVal TID)
  If MsgBox("You are about to delete this topic and" & vbNewline _
          & "any replies.  Do you wish to proceed?", _
            vbQuestion Or vbOkCancel, "UTF Discus") = vbOk Then
    With objConn
      .Open strConn
      .Execute _
        "DELETE FROM tblTopics WHERE fldTID =" & CStr(TID), , _
        adCmdText Or adExecuteNoRecords
    End With
    ListTopics_onclick
  End If
End Sub

Sub PreviewNewReply_onclick()
  PreviewReplyText.innerHTML = HTMLEncode(NewReplyForm.Text.value)
  PreviewReplyInput.style.display = "block"
End Sub

Sub SubmitNewReply_onclick()
  With NewReplyForm
    If Len(.By.value) = 0 Or Len(.Text.value) = 0 Then
      MsgBox "Please complete all fields.", vbExclamation Or vbOkOnly, "FWDiscus"
    Else
      strUser = HTMLEncode(.By.value)
      objConn.Open strConn
      With objRS
        .Open "tblReplies", objConn, adOpenDynamic, adLockPessimistic, adCmdTable
        .AddNew
        .Fields("fldTID").Value = CLng(NewReplyForm.TID.value)
        .Fields("fldPosted").Value = Now
        .Fields("fldPostedBy").Value = strUser
        .Fields("fldText").Value = HTMLEncode(NewReplyForm.Text.value)
        .Fields("fldSearchable").Value = SearchableEncode(NewReplyForm.Text.value)
        .Fields("fldEdited").Value = NEVERDATE
        .Fields("fldEditedBy").Value = ""
        .Update
        .Close
      End With
      With NewTopicForm
        .By.setAttribute "UserName", strUser
        .By.save "DiscusUserData"
      End With
      .reset
      PreviewReplyInput.style.display = "none"
      ListTopics_onclick
    End If
  End With
End Sub

Sub CancelNewReply_onclick()
  NewReplyForm.reset
  PreviewReplyInput.style.display = "none"
  ListTopics_onclick
End Sub

Sub PreviewEditReply_onclick()
  PreviewEditReplyText.innerHTML = HTMLEncode(EditReplyForm.Text.value)
  PreviewEditReplyInput.style.display = "block"
End Sub

Sub SubmitEditReply_onclick()
  Dim blnTopicHead

  With EditReplyForm
    If Len(.By.value) = 0 Or Len(.Text.value) = 0 Then
      MsgBox "Please complete all fields.", vbExclamation Or vbOkOnly, "FWDiscus"
    Else
      strUser = HTMLEncode(.By.value)
      blnTopicHead = CBool(EditReplyForm.TopicHead.value)
      objConn.Open strConn
      objConn.BeginTrans
      With objRS
        .Open "SELECT * FROM tblReplies WHERE fldRID = " & EditReplyForm.RID.value, _
              objConn, adOpenDynamic, adLockPessimistic, adCmdText
        .Fields("fldText").Value = HTMLEncode(EditReplyForm.Text.value)
        If blnTopicHead Then
          .Fields("fldSearchable").Value = SearchableEncode(EditReplyForm.Title.value) _
                                         & "|" _
                                         & SearchableEncode(EditReplyForm.Text.value)
        Else
          .Fields("fldSearchable").Value = SearchableEncode(EditReplyForm.Text.value)
        End If
        If Not blnQuietMode Then
          .Fields("fldEdited").Value = Now
          .Fields("fldEditedBy").Value = strUser
        End If
        .Update
        .Close

        If blnTopicHead Then
          .Open "SELECT fldTitle FROM tblTopics WHERE fldTID = " _
                & EditReplyForm.TID.value, _
                objConn, adOpenDynamic, adLockPessimistic, adCmdText
          .Fields("fldTitle").Value = EditReplyForm.Title.value
          .Update
          .Close
          EditReplyTitleRow.style.display = "none"
        End If
      End With
      objConn.CommitTrans
      With NewTopicForm
        .By.setAttribute "UserName", strUser
        .By.save "DiscusUserData"
      End With
      .reset
      PreviewEditReplyInput.style.display = "none"
      ListTopics_onclick
    End If
  End With
End Sub

Sub CancelEditReply_onclick()
  EditReplyForm.reset
  PreviewEditReplyInput.style.display = "none"
  ListTopics_onclick
End Sub

Sub EditReply(ByVal RID)
  objConn.Open strConn
  With objRS
    .Open "SELECT * FROM tblReplies WHERE fldRID = " & CStr(RID), _
          objConn, adOpenStatic, adLockReadOnly, adCmdText
    With EditReplyForm
      .By.value = HTMLDecode(strUser)
      .Text.value = HTMLDecode(objRS.Fields("fldText").Value)
      .TID.value = CStr(objRS.Fields("fldTID").Value)
      .RID.value = CStr(RID)
      .TopicHead.value = CStr(objRS.Fields("fldTopicHead").Value)
    End With
    .Close

    If CBool(EditReplyForm.TopicHead.value) Then
      .Open "SELECT fldTitle FROM tblTopics WHERE fldTID = " & EditReplyForm.TID.value, _
            objConn, adOpenStatic, adLockReadOnly, adCmdText
      EditReplyForm.Title.value = HTMLDecode(objRS.Fields("fldTitle").Value)
      EditReplyTitleRow.style.display = "block"
      .Close
    End If
  End With
  objConn.Close
  ShowPanel EditReplyPanel
  EditReplyForm.Text.focus
End Sub

Sub DeleteReply(ByVal RID)
  If MsgBox("You are about to delete this reply." & vbNewline _
          & "Do you wish to proceed?", _
            vbQuestion Or vbOkCancel, "UTF Discus") = vbOk Then
    With objConn
      .Open strConn
      .Execute _
        "DELETE FROM tblReplies WHERE fldRID =" & CStr(RID), , _
        adCmdText Or adExecuteNoRecords
    End With
    ListTopics_onclick
  End If
End Sub

Function Shortcut_onclick()
  Dim strLink

  If MsgBox("This will create a shortcut on your desktop for:" & vbNewline & vbNewline _
          & """" & strBTitle & """" & vbNewline & vbNewline _
          & "Do you wish to do this now?", vbOkCancel Or vbQuestion, "FWDiscus") = vbOk Then
    With New RegExp
      .Global = True
      .Pattern = "[^\w \-]"
      strLink = "\" & Left(.Replace(strBTitle, ""), 32) & ".lnk"
    End With
    With CreateObject("WScript.Shell")
      With .CreateShortcut(.SpecialFolders("Desktop") & strLink)
        .TargetPath = strHTAPath
        .WindowStyle = 1
        .IconLocation = strResourceDir & HTAICON
        .WorkingDirectory = strHTADir
        .Description = "FWDiscus Board"
        .Save
      End With
    End With
  End If
  Shortcut_onclick = False 'Cancel navigation.
End Function

Sub LockUnlock()
  If blnLocked Then
    BannerLock.src = Mid(RESFOLDER, 2) & "/FWLockSm.gif"
    NewTopic.Title = "This board has been locked"
  Else
    BannerLock.src = Mid(RESFOLDER, 2) & "/FWClearSm.gif"
    NewTopic.Title = ""
  End If
  BannerLock.alt = NewTopic.Title
  NewTopic.disabled = blnLocked
  With SettingsForm
    .BTitle.disabled = blnLocked
    .BSubtitle.disabled = blnLocked
    .BPurpose.disabled = blnLocked
    .Refresh.disabled = blnLocked
    .BTitle.Title = NewTopic.Title
    .BSubtitle.Title = NewTopic.Title
    .BPurpose.Title = NewTopic.Title
    .Refresh.Title = NewTopic.Title
  End With
  With DeleteForm
    .SubmitDelete.disabled = blnLocked
    .SubmitDelete.Title = NewTopic.Title
  End With
End Sub

Function LoadSettings()
  Dim DBVersion
  Dim lngRes

  LoadSettings = False
  DBVersion = DBVersionTest()
  Select Case DBVersion
    Case ""
      lngRes = MsgBox("There is no FWDiscus database present." _
                    & vbNewLine _
                    & vbNewLine _
                    & "Do you wish to create an empty one?", _
                      vbQuestion Or vbYesNo, _
                      "FWDiscus")
      If lngRes = vbNo Then 
        window.close
        Exit Function
      Else
        CreateDB
      End If
    Case DBVERSION
      'Compatible version.  Fall through.
    Case Else
      MsgBox "The FWDiscus database found is not compatible" _
           & vbNewLine _
           & "with this version of FWDiscus." _
           & vbNewLine _
           & vbNewLine _
           & "You must manually convert the database or" _
           & vbNewLine _
           & "remove it and rerun FWDiscus to create a new," _
           & vbNewLine _
           & "empty database.", _
             vbCritical Or vbOkOnly, _
             "FWDiscus"
      window.close
      Exit Function
  End Select

  With objRS
    .Open "tblInfo", objConn, adOpenStatic, adLockReadOnly, adCmdTable
    BannerTitle.innerHTML = .Fields("fldTitle").Value
    BannerSubtitle.innerHTML = .Fields("fldSubtitle").Value
    BannerPurpose.innerHTML = .Fields("fldPurpose").Value
    intRefresh = .Fields("fldRefresh").Value
    blnLocked = .Fields("fldLocked").Value
    .Close
    strBTitle = BannerTitle.innerHTML
    strBSubtitle = BannerSubtitle.innerHTML
    strBPurpose = BannerPurpose.innerHTML
    LockUnlock
  End With
  LoadSettings = True
End Function

Function ValidateSettings()
  Dim intRefreshTemp

  If Len(SettingsForm.BTitle.value) = 0 Or Len(SettingsForm.BSubtitle.value) = 0 _
    Or Len(SettingsForm.BPurpose.value) = 0 Or Not IsNumeric(SettingsForm.Refresh.value) Then
      MsgBox "Please complete all fields.", vbExclamation Or vbOkOnly, "FWDiscus"
      ValidateSettings = False
  Else
    intRefreshTemp = CInt(SettingsForm.Refresh.value)
    If 5 > intRefreshTemp Or intRefreshTemp > 30 Then
      MsgBox "Autorefresh out of range.", vbExclamation Or vbOkOnly, "FWDiscus"
      ValidateSettings = False
    ElseIf Not blnLocked And SettingsForm.Locked.checked Then
      If MsgBox("Locking this board will prevent new topics, replies," & vbNewline _
              & "and deletes.  Do you wish to lock it now?", _
                vbQuestion Or vbOkCancel, "FWDiscus") = vbCancel Then
        ValidateSettings = False
      Else
        ValidateSettings = True
      End If
    ElseIf blnLocked And Not SettingsForm.Locked.checked Then
      If MsgBox("This board was locked for a reason." & vbNewline _
              & "Do you wish to unlock it now?", _
                vbQuestion Or vbOkCancel, "FWDiscus") = vbCancel Then
        ValidateSettings = False
      Else
        ValidateSettings = True
      End If
    Else
      ValidateSettings = True
    End If
  End If
End Function

Sub PreviewSettings_onclick()
  If ValidateSettings() Then
    BannerTitle.innerHTML = HTMLEncode(SettingsForm.BTitle.value)
    BannerSubtitle.innerHTML = HTMLEncode(SettingsForm.BSubtitle.value)
    BannerPurpose.innerHTML = HTMLEncode(SettingsForm.BPurpose.value)
  End If
End Sub

Sub SubmitSettings_onclick()
  If ValidateSettings() Then
    With SettingsForm
      strBTitle = HTMLEncode(.BTitle.value)
      strBSubtitle = HTMLEncode(.BSubtitle.value)
      strBPurpose = HTMLEncode(.BPurpose.value)
      intRefresh = CInt(.Refresh.value)
      blnLocked = .Locked.checked
    End With
    objConn.Open strConn
    With objRS
      .Open "tblInfo", objConn, adOpenDynamic, adLockPessimistic, adCmdTable
      .Fields("fldTitle").Value = strBTitle
      .Fields("fldSubtitle").Value = strBSubtitle
      .Fields("fldPurpose").Value = strBPurpose
      .Fields("fldRefresh").Value = intRefresh
      .Fields("fldLocked").Value = blnLocked
      .Update
      .Close
    End With
    BannerTitle.innerHTML = strBTitle
    BannerSubtitle.innerHTML = strBSubtitle
    BannerPurpose.innerHTML = strBPurpose
    LockUnlock
    window.clearInterval intTimer
    intRefreshCount = intRefresh * 2 'We count down half-minute intervals.
    intTimer = window.setInterval("RefreshTopicsList()", 30000)
    ListTopics_onclick
  End If
End Sub

Sub CancelSettings_onclick()
  BannerTitle.innerHTML = strBTitle
  BannerSubtitle.innerHTML = strBSubtitle
  BannerPurpose.innerHTML = strBPurpose
  ListTopics_onclick
End Sub

Function ValidateDelete()
  Dim intX
  Dim intChecked

  intChecked = 0
  For intX = 0 To DeleteForm.Age.length - 1
    If DeleteForm.Age(intX).checked Then intChecked = intChecked + 1
  Next
  If intChecked <> 1 Then
    MsgBox "Please check one (1) option.", vbExclamation Or vbOkOnly, "FWDiscus"
    ValidateDelete = False
  ElseIf MsgBox("You are about to delete old topics and" & vbNewline _
              & "their replies.  Do you wish to proceed?", _
                vbQuestion Or vbOkCancel, "UTF Discus") = vbCancel Then
    ValidateDelete = False
  Else
    ValidateDelete = True
  End If
End Function

Sub SubmitDelete_onclick()
  Dim strInterval

  If ValidateDelete() Then
    With DeleteForm
      If .Age(0).checked Then
        strInterval = "d"
      ElseIf .Age(1).checked Then
        strInterval = "ww"
      ElseIf .Age(2).checked Then
        strInterval = "m"
      ElseIf .Age(3).checked Then
        strInterval = "yyyy"
      End If
    End With
    With objConn
      .Open strConn
      .Execute _
          "DELETE FROM tblTopics WHERE fldPosted < #" _
        & CStr(DateAdd(strInterval, -1, Date)) _
        & "#", , _
          adCmdText Or adExecuteNoRecords
    End With
    ListTopics_onclick
  End If
End Sub

Function PerformMaint()
  With CreateObject("Scripting.FileSystemObject")
    On Error Resume Next
    .DeleteFile strResourceDir & BACKUPDB
    On Error GoTo 0
    Err.Clear
    .GetFile(strResourceDir & DB).Name = Mid(BACKUPDB, 2) 'Drop leading "\".
    CreateObject("WScript.Shell").Run """" & strResourceDir & JETCOMP _
                                    & """ -src:""" & strResourceDir & BACKUPDB _
                                    & """ -dest:""" & strResourceDir & DB & """", _
                                      0, True
    If .FileExists(strResourceDir & DB) Then
      MaintForm.MaintGif.src = Mid(RESFOLDER, 2) & "/FWComplete.gif"
      MsgBox "Database maintenance complete.", vbOkOnly Or vbInformation, "FWDiscus"
      PerformMaint = True
    Else
      MaintForm.MaintGif.src = Mid(RESFOLDER, 2) & "/FWFailed.gif"
      .GetFile(strResourceDir & BACKUPDB).Name = Mid(DB, 2) 'Drop leading "\".
      MsgBox "Database maintenance failed.  Old database restored." & vbNewline _
           & "Try again when the database is not in use.", vbOkOnly Or vbCritical, "FWDiscus"
      PerformMaint = False
    End If
  End With
  MaintForm.SubmitMaint.disabled = False
End Function

Sub SubmitMaint_onclick()
  With Maintform
    .SubmitMaint.disabled = True
    .MaintGif.src = Mid(RESFOLDER, 2) & "/FWWorking.gif"
  End With
  window.setTimeout "PerformMaint()", 2000
End Sub

Function Settings_onclick()
  With SettingsForm
    .BTitle.value = HTMLDecode(strBTitle)
    .BSubtitle.value = HTMLDecode(strBSubtitle)
    .BPurpose.value = HTMLDecode(strBPurpose)
    .Refresh.value = CStr(intRefresh)
    .Locked.checked = blnLocked
    With MaintForm
      .SubmitMaint.disabled = False
      .MaintGif.src = Mid(RESFOLDER, 2) & "/FWClear.gif"
    End With
    ShowPanel SettingsPanel
    If .BTitle.disabled Then
      .Locked.focus
    Else
      .BTitle.focus
    End If
  End With
  Settings_onclick = False 'Cancel navigation.
End Function

Sub SubmitSearch_onclick()
  Dim strQuery

  If Len(Trim(SearchForm.SearchString.value)) = 0 Then
    MsgBox "Please enter a search string.", vbOkOnly Or vbExclamation, "FWDiscus"
  Else
    strQuery = _
        "SELECT DISTINCT fldTID, fldTitle, fldPosted, fldPostedBy, fldViews," _
                     & " (SELECT Count(1) FROM tblReplies" _
                       & " WHERE tblTopics.fldTID = tblReplies.fldTID) As ReplyCount" _
      & " FROM tblTopics WHERE fldTID IN (SELECT fldTID FROM tblReplies" _
                                       & ParseSearchString(SearchForm.SearchString.value) _
                                       & ")" _
        & " ORDER BY fldPosted DESC"

    SearchResultsBody.innerHTML = GetTopics(strQuery, "found")
    LastSearch.innerHTML = HTMLEncode(SearchForm.SearchString.value)
    SearchResults.disabled = False
    SearchResults.title = ""
    ShowPanel SearchResultsPanel
  End If
End Sub

Function SearchForm_onsubmit()
  'Weird bug?  If a form has one <INPUT type="text"> field,
  'pressing ENTER seems to attempt to *submit* the form!

  SubmitSearch_onclick
  SearchForm_onsubmit = False 'Cancel navigation.
End Function

Sub CancelSearch_onclick()
  SearchForm.reset
  ListTopics_onclick
End Sub

Sub ResetSearch_onclick()
  SearchForm.reset
  SearchForm.SearchString.focus
End Sub

Function Search_onclick()
  ShowPanel SearchPanel
  SearchForm.SearchString.focus
  Search_onclick = False 'Cancel navigation.
End Function

Function SearchResults_onclick()
  ShowPanel SearchResultsPanel
  SearchResults_onclick = False 'Cancel navigation.
End Function

Function CloseApp_onclick()
  window.close
  CloseApp_onclick = False 'Cancel navigation.
End Function

Sub PrintPage_onclick()
  window.print
End Sub

Sub window_onload()
  blnQuietMode = InStr(1, App.commandLine & " ", " /q ", vbTextCompare) > 0
  If blnQuietMode Then
    MsgBox "FWDiscus launched in Quiet Mode." & vbNewLine & vbNewLine _
         & "View counts will not be incremented" & vbNewLine _
         & "and edits will not be noted.", vbOkOnly Or vbInformation, _
           "FWDiscus"
  End If
  BuildGlobalStrings
  If StrComp(strHTAName, App.applicationName, vbTextCompare) = 0 Then
    document.title = App.applicationName & " " & App.version
  Else
    document.title = strHTAName & " " & App.applicationName & " " & App.version
  End If
  Set objConn = CreateObject("ADODB.Connection")
  Set objRS = CreateObject("ADODB.Recordset")
  Set dicVisited = CreateObject("Scripting.Dictionary")
  If LoadSettings() Then
    NewTopicForm.By.load "DiscusUserData"
    strUser = NewTopicForm.By.getAttribute("UserName")
    If IsNull(strUser) Then strUser = ""
    intRefreshCount = intRefresh * 2 'We count down half-minute intervals.
    intTimer = window.setInterval("RefreshTopicsList()", 30000)
    ListTopics_onclick
  End If
End Sub

Sub window_onunload()
  dicVisited.RemoveAll
  Set dicVisited = Nothing
  Set objRS = Nothing
  Set objConn = Nothing
End Sub
